# coding: utf-8

"""
    MailSlurp API

    MailSlurp is an API for sending and receiving emails and SMS from dynamically allocated email addresses and phone numbers. It's designed for developers and QA teams to test applications, process inbound emails, send templated notifications, attachments, and more.  ## Resources  - [Homepage](https://www.mailslurp.com) - Get an [API KEY](https://app.mailslurp.com/sign-up/) - Generated [SDK Clients](https://docs.mailslurp.com/) - [Examples](https://github.com/mailslurp/examples) repository  # noqa: E501

    The version of the OpenAPI document: 6.5.2
    Contact: contact@mailslurp.dev
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from mailslurp_client.configuration import Configuration


class EmailFeatureNames(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'family': 'list[EmailFeatureFamilyName]',
        'platform': 'list[EmailFeaturePlatformName]',
        'category': 'list[EmailFeatureCategoryName]'
    }

    attribute_map = {
        'family': 'family',
        'platform': 'platform',
        'category': 'category'
    }

    def __init__(self, family=None, platform=None, category=None, local_vars_configuration=None):  # noqa: E501
        """EmailFeatureNames - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._family = None
        self._platform = None
        self._category = None
        self.discriminator = None

        self.family = family
        self.platform = platform
        self.category = category

    @property
    def family(self):
        """Gets the family of this EmailFeatureNames.  # noqa: E501


        :return: The family of this EmailFeatureNames.  # noqa: E501
        :rtype: list[EmailFeatureFamilyName]
        """
        return self._family

    @family.setter
    def family(self, family):
        """Sets the family of this EmailFeatureNames.


        :param family: The family of this EmailFeatureNames.  # noqa: E501
        :type: list[EmailFeatureFamilyName]
        """
        if self.local_vars_configuration.client_side_validation and family is None:  # noqa: E501
            raise ValueError("Invalid value for `family`, must not be `None`")  # noqa: E501

        self._family = family

    @property
    def platform(self):
        """Gets the platform of this EmailFeatureNames.  # noqa: E501


        :return: The platform of this EmailFeatureNames.  # noqa: E501
        :rtype: list[EmailFeaturePlatformName]
        """
        return self._platform

    @platform.setter
    def platform(self, platform):
        """Sets the platform of this EmailFeatureNames.


        :param platform: The platform of this EmailFeatureNames.  # noqa: E501
        :type: list[EmailFeaturePlatformName]
        """
        if self.local_vars_configuration.client_side_validation and platform is None:  # noqa: E501
            raise ValueError("Invalid value for `platform`, must not be `None`")  # noqa: E501

        self._platform = platform

    @property
    def category(self):
        """Gets the category of this EmailFeatureNames.  # noqa: E501


        :return: The category of this EmailFeatureNames.  # noqa: E501
        :rtype: list[EmailFeatureCategoryName]
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this EmailFeatureNames.


        :param category: The category of this EmailFeatureNames.  # noqa: E501
        :type: list[EmailFeatureCategoryName]
        """
        if self.local_vars_configuration.client_side_validation and category is None:  # noqa: E501
            raise ValueError("Invalid value for `category`, must not be `None`")  # noqa: E501

        self._category = category

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EmailFeatureNames):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, EmailFeatureNames):
            return True

        return self.to_dict() != other.to_dict()
